package com.joyful.euphoria.board.assistant;

import android.annotation.SuppressLint;
import android.graphics.drawable.Drawable;

import android.media.MediaPlayer;
import android.util.Log;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.view.inputmethod.InputConnection;
import android.widget.ImageView;
import android.widget.VideoView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.bumptech.glide.Glide;
import com.bumptech.glide.integration.webp.decoder.WebpDrawable;
import com.bumptech.glide.load.DataSource;
import com.bumptech.glide.load.engine.GlideException;
import com.bumptech.glide.request.RequestListener;
import com.bumptech.glide.request.target.Target;
import com.joyful.euphoria.board.EuphoriaBoard;
import com.joyful.euphoria.board.R;
import com.joyful.euphoria.board.utils.KeyNamesUtils;
import com.joyful.euphoria.board.utils.Normal;
import com.joyful.euphoria.board.utils.SaveCurrentThemeUtils;
import com.joyful.euphoria.board.boardcode.BoardCode;
import com.joyful.euphoria.board.boardcode.BoardViewCode;


import kotlin.Unit;
import kotlin.jvm.functions.Function2;

public class ServiceAssistant extends android.inputmethodservice.InputMethodService implements BoardViewCode.OnKeyboardActionListener {


    private ViewCodeAssistant keyBoardView;
    private BoardCode mKeyBoard;
    private View parentView;


    private ImageView imBG;
    private VideoView videoView;

    private int a = R.xml.xml_one;
    private int b = R.xml.xml_two;
    private int c = R.xml.xml_three;

    private int curImeAction = EditorInfo.IME_ACTION_UNSPECIFIED;

    @SuppressLint("InflateParams")
    @Override
    public View onCreateInputView() {
        parentView = getLayoutInflater().inflate(R.layout.default_keyboard, null);
        findView();
        return parentView;
    }

    private void findView() {

        imBG = parentView.findViewById(R.id.gif_bg);
        videoView = parentView.findViewById(R.id.video_view);
        mKeyBoard = new BoardCode(this, a);
        keyBoardView = parentView.findViewById(R.id.custom_input_view);
        keyBoardView.setEnabled(true);
        keyBoardView.setPreviewEnabled(false);
        keyBoardView.setKeyboard(mKeyBoard);
        keyBoardView.setOnKeyboardActionListener(this);
    }


    @Override
    public void onWindowHidden() {
        super.onWindowHidden();
        if (videoView.isPlaying()) {
            videoView.pause();

        }
    }

    @Override
    public void onWindowShown() {
        super.onWindowShown();
        EditorInfo currentInputEditorInfo = getCurrentInputEditorInfo();
        curImeAction = Normal.INSTANCE.getTextForImeAction(currentInputEditorInfo.imeOptions);
        String skinPath = SaveCurrentThemeUtils.INSTANCE.getSkinPath();

        if (skinPath == null || skinPath.isEmpty()) {
            Log.d(EuphoriaBoard.TAG, "---------skinPath= bull");
            keyBoardView.updateUi(curImeAction);
        } else {
            Log.d(EuphoriaBoard.TAG, "---------skinPath= 1111");
            KeyboardActionAssistant.INSTANCE.readBgOrVideo(this, new Function2<String, Drawable, Unit>() {
                @Override
                public Unit invoke(String s, Drawable drawable) {
                    Log.d(EuphoriaBoard.TAG, "---------s= " + s + "---------drawable=" + drawable);
                    if (s != null) {
                        keyBoardView.setBackground(null);
                        if (s.endsWith(".gif")) {
                            imBG.setVisibility(View.VISIBLE);
                            videoView.setVisibility(View.GONE);
                            Glide.with(ServiceAssistant.this)
                                    .load(s)
                                    .addListener(new RequestListener<Drawable>() {
                                        @Override
                                        public boolean onLoadFailed(@Nullable GlideException e, @Nullable Object model, @NonNull Target<Drawable> target, boolean isFirstResource) {
                                            return false;
                                        }

                                        @Override
                                        public boolean onResourceReady(@NonNull Drawable resource, @NonNull Object model, Target<Drawable> target, @NonNull DataSource dataSource, boolean isFirstResource) {
                                            if (resource instanceof WebpDrawable) {
                                                ((WebpDrawable) resource).setLoopCount(WebpDrawable.LOOP_FOREVER);
                                            }
                                            return false;
                                        }
                                    }).into(imBG);
                        } else if (s.endsWith(".mp4")) {
                            imBG.setVisibility(View.GONE);
                            videoView.setVisibility(View.VISIBLE);
                            videoView.setVideoPath(s);
                            videoView.start();
                            videoView.setOnPreparedListener(new MediaPlayer.OnPreparedListener() {
                                @Override
                                public void onPrepared(MediaPlayer mp) {
                                    mp.setLooping(true);
                                }
                            });
                        }

                    } else {
                        keyBoardView.setBackground(drawable);
                    }
                    keyBoardView.updateUi(curImeAction);
                    return null;
                }
            });
        }


    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        if (videoView != null) {
            videoView.stopPlayback();
            videoView = null;
        }

    }

    @Override
    public void onPress(int primaryCode) {

    }

    @Override
    public void onRelease(int primaryCode) {

    }

    @Override
    public void onKey(int primaryCode, int[] keyCodes) {

        InputConnection curInputConnect = getCurrentInputConnection();
        switch (primaryCode) {
            case KeyNamesUtils.KEY_CODE_DELETE:
                curInputConnect.deleteSurroundingText(1, 0);
                break;
            case KeyNamesUtils.KEY_CODE_SHIFT:
                switchShift();
                break;
            case KeyNamesUtils.KEY_CODE_NUMBER_SHIFT:
            case KeyNamesUtils.KEY_CODE_SYMBOL_SHIFT:
                switchMoreOrNumber();
                break;
            case KeyNamesUtils.KEY_CODE_CHANGE_NUMBER:
            case KeyNamesUtils.KEY_CODE_BACK:
                switchNormalOrNumber();
                break;

            case KeyNamesUtils.KEY_CODE_COMPLETE:
            case KeyNamesUtils.KEY_CODE_CANCEL:
                curInputConnect.performEditorAction(curImeAction);
//                curInputConnect.performEditorAction(EditorInfo.IME_ACTION_DONE);
                break;
            default:
                String codeToChar = KeyboardActionAssistant.INSTANCE.primaryCodeToChar(primaryCode);
                curInputConnect.commitText(codeToChar, 1);
                if (keyBoardView.isLowerCase() == 1) {
                    //自动转小写
                    keyBoardView.setLowerCase(0);
                    KeyboardActionAssistant.INSTANCE.keyToLowerCase(mKeyBoard);
                    keyBoardView.setKeyboard(mKeyBoard);
                }
                break;

        }


    }

    private void switchMoreOrNumber() {
        int mode = keyBoardView.getMode();
        switch (mode) {
            case 1:
                mKeyBoard = new BoardCode(this, c);
                keyBoardView.setMode(2);
                keyBoardView.setKeyboard(mKeyBoard);
                break;
            case 2:
                mKeyBoard = new BoardCode(this, b);
                keyBoardView.setMode(1);
                keyBoardView.setKeyboard(mKeyBoard);
                break;
        }

    }

    private void switchNormalOrNumber() {
        int mode = keyBoardView.getMode();
        switch (mode) {
            case 0:
                mKeyBoard = new BoardCode(this, b);
                keyBoardView.setMode(1);
                keyBoardView.setKeyboard(mKeyBoard);
                break;
            case 1:
            case 2:
                mKeyBoard = new BoardCode(this, a);
                keyBoardView.setMode(0);
                keyBoardView.setKeyboard(mKeyBoard);
                break;
        }

    }

    private void switchShift() {
        int lowerCase = keyBoardView.isLowerCase();
        switch (lowerCase) {
            case 0:
                //当前小写转大写
                keyBoardView.setLowerCase(1);
                KeyboardActionAssistant.INSTANCE.keyToUpper(mKeyBoard);
                keyBoardView.setKeyboard(mKeyBoard);
                break;
            case 1:
                //当前大写转锁定大写
                keyBoardView.setLowerCase(2);
                break;
            case 2:
                //当前锁定大写转小写
                keyBoardView.setLowerCase(0);
                KeyboardActionAssistant.INSTANCE.keyToLowerCase(mKeyBoard);
                keyBoardView.setKeyboard(mKeyBoard);
                break;
        }
    }


    @Override
    public void onText(CharSequence text) {

    }

    @Override
    public void swipeLeft() {

    }

    @Override
    public void swipeRight() {

    }

    @Override
    public void swipeDown() {

    }

    @Override
    public void swipeUp() {

    }


}
